package blusunrize.immersiveengineering.common.items;

import blusunrize.immersiveengineering.api.tool.IInternalStorageItem;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagList;

public abstract class ItemInternalStorage extends ItemIEBase implements IInternalStorageItem 
{
	public ItemInternalStorage(String name, int stackSize, String... subNames)
	{
		super(name, stackSize, subNames);
	}
	
	@Override
	public ItemStack[] getContainedItems(ItemStack stack)
	{
		ItemStack[] stackList = new ItemStack[getInternalSlots(stack)];
		if(stack.func_77942_o())
		{
			NBTTagList inv = stack.func_77978_p().func_150295_c("Inv",10);
			for (int i=0; i<inv.func_74745_c(); i++)
			{
				NBTTagCompound tag = inv.func_150305_b(i);
				int slot = tag.func_74771_c("Slot") & 0xFF;
				if ((slot >= 0) && (slot < stackList.length))
					stackList[slot] = ItemStack.func_77949_a(tag);
			}
		}
		return stackList;
	}
	
	@Override
	public void setContainedItems(ItemStack stack, ItemStack[] stackList)
	{
		NBTTagList inv = new NBTTagList();
		for (int i = 0; i < stackList.length; i++)
			if (stackList[i] != null)
			{
				NBTTagCompound tag = new NBTTagCompound();
				tag.func_74774_a("Slot", (byte)i);
				stackList[i].func_77955_b(tag);
				inv.func_74742_a(tag);
			}
		if(stack.func_77942_o())
		{
			NBTTagList invExisting = stack.func_77978_p().func_150295_c("Inv",10);
			for (int i=0; i<invExisting.func_74745_c(); i++)
			{
				NBTTagCompound tag = invExisting.func_150305_b(i);
				int slot = tag.func_74771_c("Slot") & 0xFF;
				if ((slot >= stackList.length) && (slot < stackList.length))
					inv.func_74742_a(tag);
			}
		}
		else
			stack.func_77982_d(new NBTTagCompound());
		stack.func_77978_p().func_74782_a("Inv",inv);
	}

	@Override
	public abstract int getInternalSlots(ItemStack stack);
}
